config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  scope "(:locale)", locale: /#{I18n.available_locales.join("|")}/ do
    root 'static#home'
    get '/about', to: 'static#about'
    devise_for :users
    resource :study_group, only: %i[show]
    resources :meetings, only: %i[update]
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/host.rb
class Host < ApplicationRecord
  belongs_to :user
  validates :timezone, presence: true
  
  scope :next_meeting, ->(host) { Meeting.where('host_id = ? AND meeting_time > ?', host.id, (DateTime.now - 55.minutes)).order(meeting_time: :asc).limit(1) }

  
  has_many :meetings
end

app/models/meeting.rb
class Meeting < ApplicationRecord
  has_one :host
  validates :meeting_time, :meeting_url, presence: true
  validates :meeting_time, uniqueness: true
  
  scope :coming_meetings, -> { where('meeting_time > ?', (DateTime.now - 55.minutes)).order(meeting_time: :asc) }
  scope :next_meeting, ->(host) { where('host_id = ? AND meeting_time > ?', host.id, (DateTime.now - 55.minutes)).order(meeting_time: :asc).limit(1) }
  
  scope :new_meeting, ->(host) { new(id: next_meeting_id, host_id: host.id, meeting_time: next_available_day(host)) }
  
  def self.next_meeting_id
    previous_meeting = Meeting.last&.id 
    previous_meeting ? previous_meeting + 1 : 1
  end
  
  def self.next_available_day(host)
    host_time_offset = Time.now.in_time_zone(host.timezone).utc_offset / 3600
    set_host_time = {
       hour: host.meeting_time['hour'] + host_time_offset,
       min: host.meeting_time['minute']
    }
    
    now = DateTime.now.change(set_host_time)
    
    now += 1 + ((host.meeting_day - now.wday) % 7)
  end
  
  def meeting_time=(value)
    host_timezone = Host.find(host_id).timezone
    super(value.to_datetime - Time.now.in_time_zone(host_timezone).utc_offset.seconds)
  end
end

app/models/member.rb
class Member < ApplicationRecord
  belongs_to :user
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
  validates :username, :birthdate, :language, presence: true
  validates :username, uniqueness: true
  
  has_one :host
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :set_locale
  before_action :configure_permitted_parameters, if: :devise_controller?

  http_basic_authenticate_with name: ENV['HTTP_UN'], password: ENV['HTTP_PW'], if: -> { ENV['HTTP_PW'] }

  def set_locale
    I18n.locale = params[:locale] || I18n.default_locale
  end

  def default_url_options
    { locale: I18n.locale }
  end

  def configure_permitted_parameters
    user_params = %i[username birthdate language]

    devise_parameter_sanitizer.permit(:sign_up, keys: user_params)
    devise_parameter_sanitizer.permit(:account_update, keys: user_params)
  end
end

app/controllers/meetings_controller.rb
class MeetingsController < ApplicationController
  before_action :authenticate_user!

  def show; end
  
  def update
    current_host = current_user.host

    next_meeting = Host.next_meeting(current_host).presence || current_host.meetings.new({host_id: current_host.id}.merge(meeting_params))

    current_host && next_meeting.update(meeting_params)

    redirect_back fallback_location:  root_url
  end
  
  private 

  def meeting_params
    params.require(:meeting).permit(:meeting_url, :meeting_time, :challenge_link)
  end
end

app/controllers/static_controller.rb
class StaticController < ApplicationController
  def about; end

  def home;  end
end

app/controllers/study_groups_controller.rb
class StudyGroupsController < ApplicationController  
  def show
    @meetings = Meeting.coming_meetings

    render html: nil, layout: true
  end
  
  def new
    render html: nil, layout: true
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
  def toggle_switch_settings(content_id)
    {
      aria: {
        controls: content_id,
        expanded: 'false',
        label: 'Toggle navigation'
      },
      data: {
        bs: {
          target: "##{content_id}",
          toggle: 'collapse'
        }
      },
      type: :button
    }
  end
  
  def next_host_meeting(host)
    Meeting.next_meeting(host).first || Meeting.new_meeting(host)
  end
end

app/helpers/carousel_helper.rb
module CarouselHelper
  def carousel_items
    [
      {
        image: 'https://i.ibb.co/dWvp1GD/zil.jpg',
        title: 'Zil\'s Portfolio',
        description: 'This is my personal portfolio website.
        Built on React and Ruby on Rails.
        This was built with responsiveness in mind.',
        link: 'https://github.com/zilton7/portfolio',
        alt: 'Zil\'s Portfolio image',
        dark: true
      },
      {
        image: 'https://i.ibb.co/84bcq6f/brandon.jpg',
        title: 'Alien Invasion',
        description: 'The project is a JavaScript based game using the Phaser3 library',
        link: 'https://quirky-nobel-917e25.netlify.app/',
        alt: 'Brandon\'s Alien Invasion image',
        dark: false
      }
    ]
  end
  
  def carousel_scroll_settings(direction)
    {
      type: 'button',
      data: {
        bs_slide: direction,
        bs_target: '#homepage-carousel'
      }
    }
  end
end

app/helpers/form_helper.rb
module FormHelper
  def host_form_options(resource_name)
    {
      as: resource_name,
      url: meeting_path(resource_name),
      html: {
        method: :put,
        class: 'd-flex px-5 pt-3 pb-5 justify-content-center align-items-center flex-wrap'
        }
      }
  end
  
  def user_form_options(resource_name, action_name)
    {
      as: resource_name,
      url: registration_path(resource_name),
      html: {
        method: (action_name == 'edit' ? :put : :post),
        class: 'px-5 pt-3 pb-5'
        }
      }
  end
  
  def available_languages
    languages = I18n.available_locales.sort.map do |locale_key|
      [t("#{locale_key}"), locale_key.to_s]
    end
    
    languages << [t('.other'), 'Other']
  end
  
  def submit_for(action_name)
    (action_name == 'edit' ? t('update') : t('sign_up'))
  end
end

app/helpers/members_helper.rb
module MembersHelper
  def member_list
    [
      {
        name: 'Kristina',
        gender: 'female',
        title: 'Administrator',
        avatar: 'avatar-wm.png',
        facebook: '/',
        twitter: '/',
        instagram: '/',
        linkedin: '/'
      },
      {
        name: 'Brandon Defoe',
        gender: 'male',
        title: 'Developer',
        avatar: 'avatar-m1.png',
        facebook: '/',
        twitter: '/',
        instagram: '/',
        linkedin: '/'
      },
      {
        name: 'Mert Gündüz',
        gender: 'male',
        title: 'Developer',
        avatar: 'avatar-m1.png',
        facebook: '/',
        twitter: '/',
        instagram: '/',
        linkedin: '/'
      },
      {
        name: 'Zil Norvilis',
        gender: 'male',
        title: 'Developer',
        avatar: 'avatar-m3.png',
        facebook: '/',
        twitter: '/',
        instagram: '/',
        linkedin: '/'
      },
      {
        name: 'Eduardo Rodriguez',
        gender: 'male',
        title: 'Developer',
        avatar: 'avatar-m2.png',
        facebook: '/',
        twitter: '/',
        instagram: '/',
        linkedin: '/'
      },
      {
        name: 'Daniel Samuel',
        gender: 'male',
        title: 'Developer',
        avatar: 'avatar-m2.png',
        facebook: '/',
        twitter: '/',
        instagram: '/',
        linkedin: '/'
      }
    ]
  end
end

app/helpers/study_groups_helper.rb
module StudyGroupsHelper
  def component_props(action_name)
    case action_name
      when 'show'
        {
          sessions: @meetings,
          language: I18n.locale,
          locale: current_user&.locale,
          url: @meetings&.first&.meeting_url,
          challenge: @meetings&.first&.challenge_link
        }
      when 'new'
        {username: current_user&.name || 'Guest', language: I18n.locale}
    end
  end

  def transform_datetime_string(datetime, timezone)
    split = datetime.in_time_zone(timezone).to_s.split(' ')
    [split[0], split[1].split(':')[..1].join(':')].join('T')
  end
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>NephilidEngineering</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <%= favicon_link_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-gtEjrD/SeCtmISkJkNUaaKMoLD0//ElJ19smozuHV6z3Iehds+3Ulb9Bn9Plx0x4" crossorigin="anonymous"></script>
  </head>

  <body>
    <%= render 'shared/navbar' %>
    <%= render 'shared/flash_messages' %>
    <%= render 'shared/host_panel', resource: next_host_meeting(current_user.host) if current_user&.host.present?  %>
    <%= render 'shared/body' %>
  </body>
</html>

app/views/shared/_body.html.haml
- if controller_name == 'study_groups'
  = react_component("#{controller_name}/#{action_name}", component_props(action_name))
- else
  = yield

app/views/shared/_change_locale.html.haml
.nav-item.dropdown
  %a.nav-link.dropdown-toggle#navbar-dropdown{ aria_expanded: 'false',
    data: { bs_toggle: 'dropdown' }, role: 'button' }
    = t('.language')
  .dropdown-menu#navbar-menu{ aria_labelledby: 'navbar-dropdown',
    class: 'bg-dark dropdown-menu-dark border-0' }
    - I18n.available_locales.sort.each do |locale|
      %a.dropdown-item{ href: url_for(locale: locale) }= t(locale)

app/views/shared/_flash_messages.html.haml
- if notice
  %p.alert.alert-success= notice

- if alert
  %p.alert.alert-danger= alert

app/views/shared/_host_panel.html.haml
.container.d-flex.justify-content-center.flex-column#host-panel
  %button.navbar-toggler{ toggle_switch_settings('set-meeting') }
    %span Update Next Meeting
  .collapse.navbar-collapse#set-meeting
    = form_for(resource, host_form_options(resource)) do |f|
      = render 'devise/shared/error_messages', resource: resource
      
      .field.d-flex.flex-wrap.col-5.min-vw-75
        = f.label :meeting_url
        = f.text_field :meeting_url, autofocus: true, autocomplete: 'meeting_url', class: 'form-control'
      
      .field.d-flex.flex-wrap.col-5.min-vw-75
        = f.label :challenge_link
        = f.text_field :challenge_link, autocomplete: 'challenge_link', class: 'form-control'
                
      .field.d-flex.flex-wrap.col-4.mx-1.min-vw-25
        = f.label :meeting_time, class: 'text-nowrap'
        -# = f.time_field :meeting_time, class: 'form-control', value: transform_datetime_string(f.object.meeting_time, Host.find(f.object.host_id).timezone).split('T')[1]
        = f.datetime_field :meeting_time, class: 'form-control', value: transform_datetime_string(f.object.meeting_time, Host.find(f.object.host_id).timezone)
      
      .actions.mt-4.d-flex.justify-content-center
        = f.submit 'Update', class: 'btn btn-dark'

app/views/shared/_navbar.html.haml
%nav.navbar.navbar-expand-lg.navbar-dark.bg-dark
  .container-fluid
    = link_to 'Nephilid', root_path, class: 'navbar-brand'
    %button.navbar-toggler{ toggle_switch_settings('navbar-content') }
      %span.navbar-toggler-icon
    .collapse.navbar-collapse#navbar-content
      %ul.navbar-nav.me-auto.mb-2.mb-lg-0
        %li.nav-item
          = link_to t('.home'), root_path, class: 'nav-link active'
        %li.nav-item
          = link_to t('.about_us'), about_path, class: 'nav-link'
        %li.nav-item
          = link_to t('DSA'), study_group_path, class: 'nav-link'

        - if user_signed_in?
          = link_to t('edit_profile'), edit_user_registration_path, class: 'nav-link'
          = link_to t('logout'), destroy_user_session_path, class: 'nav-link', method: :delete
        - else
          = link_to t('sign_up'), new_user_registration_path, class: 'nav-link'
          = link_to t('login'), new_user_session_path, class: 'nav-link'
      %ul.navbar-nav.mr-auto
        = render 'shared/change_locale'